Name: ocaml
Version: 3.08.1
Release: 2%{?distro_release:.%{distro_release}}
Summary: The Objective Caml compiler and programming environment
Source0: http://caml.inria.fr/distrib/ocaml-3.08/ocaml-3.08.1.tar.gz
Source1: http://caml.inria.fr/distrib/ocaml-3.08/ocaml-3.08-refman.html.tar.gz
Source2: http://caml.inria.fr/distrib/ocaml-3.08/ocaml-3.08-refman.ps.gz
Source3: http://caml.inria.fr/distrib/ocaml-3.08/ocaml-3.08-refman.info.tar.gz
License: part LGPL, part QPL
Group: Development/Languages
Vendor: INRIA Rocquencourt
URL: http://caml.inria.fr/
BuildRoot: %{_tmppath}/ocaml-buildroot
Obsoletes: ocaml-emacs, camlp4
Conflicts: ocaml-emacs, camlp4

Patch1: ocaml-3.08-wish1804.patch
Patch2: ocaml-3.08.1-bug3142.patch

%define debug_package %{nil}

%description
Objective Caml is a high-level, strongly-typed, functional and
object-oriented programming language from the ML family of languages.

This package comprises two batch compilers (a fast bytecode compiler
and an optimizing native-code compiler), an interactive toplevel system,
parsing tools (Lex,Yacc,Camlp4), a replay debugger, a documentation generator,
and a comprehensive library.

%prep
%setup -T -q -b 0
%patch1 -p0
%patch2 -p0
%setup -T -q -D -a 1
%setup -T -q -D -a 3
cp %{SOURCE2} refman.ps.gz

%build
./configure -bindir %{_bindir} -libdir %{_libdir}/ocaml -mandir %{_mandir}/man1 -with-pthread
make -j1 world opt opt.opt

%install
rm -rf %{buildroot}
make install BINDIR=%{buildroot}%{_bindir} LIBDIR=%{buildroot}%{_libdir}/ocaml MANDIR=%{buildroot}%{_mandir}
mv %{buildroot}%{_libdir}/ocaml/ld.conf %{buildroot}%{_libdir}/ocaml/ld.conf.orig
sed -e "s|^%{buildroot}||" %{buildroot}%{_libdir}/ocaml/ld.conf.orig > %{buildroot}%{_libdir}/ocaml/ld.conf
rm -f %{buildroot}%{_libdir}/ocaml/ld.conf.orig
(cd emacs; make install BINDIR=%{buildroot}%{_bindir} EMACSDIR=%{buildroot}%{_datadir}/emacs/site-lisp)
(mkdir -p %{buildroot}%{_infodir}; cd infoman; cp ocaml*.gz %{buildroot}%{_infodir})
mv -f %{buildroot}%{_bindir}/ocamlc %{buildroot}%{_bindir}/ocamlc.byte
mv -f %{buildroot}%{_bindir}/ocamlopt %{buildroot}%{_bindir}/ocamlopt.byte
ln -s ocamlc.opt %{buildroot}%{_bindir}/ocamlc
ln -s ocamlopt.opt %{buildroot}%{_bindir}/ocamlopt

# Disable build root strip policy:
# executables generated by ocamlc -custom MUST NOT BE STRIPPED
# But now that we have dynamic loading of C code, none of the executables
# in the distribution is generated by ocamlc -custom, so leave default.
# %define __spec_install_post /usr/lib/rpm/brp-compress

%files
%defattr(-, root, root)
%{_bindir}/*
%{_mandir}/man1/*
%{_mandir}/man3/*
%{_libdir}/ocaml
%{_datadir}/emacs/site-lisp/*
%{_infodir}/*

%doc README LICENSE refman.ps.gz htmlman Changes
